﻿using System;
using System.Collections.Generic;

namespace Graphics
{
    /// <summary>
    /// Represents an animation implementation of a Sprite
    /// </summary>
    public partial class Animation : Sprite
    {
        public static bool setTimeTo20 = true;
        public Sprite setCannonBallPath(int x, int y, int i, int j)
        {
            points = 10;
            transparencyKey = ' ';
            hasTransparency = true;
            Random rand = new Random();
            i = rand.Next(5) + i - 2;
            j = rand.Next(5) + j - 1;
            x = rand.Next(3) + x - 1;
            y = rand.Next(3) + y - 1;

            
            string[] ball = {"   "," o "};
            image = ball;

            double time = 10 + (int)Math.Sqrt((double)((x - i) * (x - i) + (y - j) * (y - j))) / 2.4;
            double Vinit = -1.2;

            if (setTimeTo20)
                time = 20;

            //Find verticle acceleration of ball
            double acc = 2.0 * ((-Vinit) * time + (j - y)) / (1.0 * time * time);

            for (int c = 1; c <= time; c++)
            {
                xPs.Add((int)(x + ((i - x) * c / time)));
                yPs.Add((int) ((.5*acc*(c*c)) + (Vinit)*(c) + y));

                //Adjust animation
                frames.Add(ball);
                solids.Add(ball);
            }

            string[] X = { " X ", " X "};
            for (int c = frames.Count-1; c > frames.Count - 4; c--)
            {
                solids[c] = X;
            }

            string[] miss = {@"\|/"};
            frames[frames.Count - 1] = miss;

            repeat = false;

            return this;
        }

        public bool setTorpedoPath(Sprite sub)
        {
            repeat = false;
            hasTransparency = true;
            transparencyKey = ' ';
            string[] so = {"XXX"};
            solid = so;

            Random rand = new Random();

            //Is the sub shooting to the right or left?
            int r, direction, startX;
            if (sub.flipped)
            {
                if (sub.xP - 20 < 0)
                {
                    //Too close to left edge
                    disabled = true;
                    return false;
                }
                r = rand.Next(-7, sub.xP -20);
                direction = -1;
                startX = sub.xP;
            }
            else
            {
                if (sub.xP + sub.image[0].Length + 20 > Console.BufferWidth)
                {
                    //Too close to right edge
                    disabled = true;
                    return false;
                }
                r = rand.Next(sub.xP + sub.image[0].Length + 20, Console.BufferWidth+7);
                direction = 1;
                startX = sub.xP + sub.image[0].Length-1;
            }
            //End of determining whether we're shooting right/left

            List<string[]> newFrames = new List<string[]>();
            //Set frames of torpedo running in water
            for (int c = startX; c != r; c=c+direction)
            {
                xPs.Add(c);
                yPs.Add(sub.yP+3);
                newFrames.Add(frames[Math.Abs(c)%frames.Count]);
            }
            frames = newFrames;

            //Set Explosion!!!!
            Animation exp = new Animation(@"Graphics\Library\Explosion1");
            foreach (string[] s in exp.frames)
            {
                frames.Add(s);
                xPs.Add(r-4);
                yPs.Add(sub.yP);
            }
            return true;
        }
    }
}
