﻿using System;
using Graphics;

namespace Menus
{
    public abstract class GameLayer
    {
        protected Layer buffer;
        protected Sprite cursor1;
        protected Sprite cursor2;
        protected bool exit = false;
        public LayerArgs msg = new LayerArgs();

        public class LayerArgs
        {
            public int nextLayerIndex=0;
            public int dataI=0;
            public Object obj=null;
            public string dataS="";
        }

        public abstract void runLayer(LayerArgs sender);
    }
}
